/* Copyright (c) 2003-2005, Sven Suursoho
 * See LICENSE for details */

#ifndef cool_config_hpp_included
#define cool_config_hpp_included

/**
 * \defgroup cool_config Configuration data
 * \ingroup cool
 * \{
 * This module has two separated layers -- configuration data parser and
 * storage. Parsers should read and parse input stream (file, socket etc) and
 * storage holds extracted key names and corresponding values.
 *
 * To adapt parsers for different configuration formats, inherit new parser
 * class from cool::config_parser, which defines interface. Class cool::config
 * uses methods defined by this interface to fetch keys and values from
 * configuration stream and stores these values internally.
 *
 * There is already defined parser for ini-style files: cool::ini_parser
 *
 * Header(s):
 *  - \ref config.hpp
 *  - \ref ini_parser.hpp
 * \}
 */

#include <cool/config/config.hpp>
#include <cool/config/ini_parser.hpp>


#endif  /* cool_config_hpp_included */
