/* Copyright (c) 2005, Sven Suursoho
 * See LICENSE for details */

#ifndef cool_cool_hpp_included
#define cool_cool_hpp_included

/**
 * \file cool.hpp
 * \author Sven Suursoho
 * \brief Environment-dependent compiler settings
 *
 * \note There is no need to include this file by user applications.
 */

/**
 * \defgroup cool Base module
 * \{
 * This module contains base stuff for COOL library.
 */

/**
 * \todo Do something with cool_config.hpp, so that internal macros wouldn't
 * be visible
 */
#undef PACKAGE_BUGREPORT
#undef PACKAGE_NAME
#undef PACKAGE_STRING
#undef PACKAGE_TARNAME
#undef PACKAGE_VERSION

/* Platform dependent stuff */
#if defined(unix) || defined(__unix)
/** \brief Defined if library is compiled on POSIX-compliant platform */
#  define COOL_POSIX
#endif
#include "bits/cool_config.hpp"

#undef PACKAGE_BUGREPORT
#undef PACKAGE_NAME
#undef PACKAGE_STRING
#undef PACKAGE_TARNAME
#undef PACKAGE_VERSION


/** \brief COOL class export symbol */
#define COOL_API


/* Header(s) that every application should include */
#include <assert.h>


/** \brief Replace parameter \a s with it's value as string */
#define COOL_STRINGIFY(s)   COOL_STRINGIFY_I(s)

/** \brief COOL_STRINGIFY helper macro */
#define COOL_STRINGIFY_I(s) #s

/** \brief String identifying the current code position */
#define COOL_LOCUS __FILE__ ":" COOL_STRINGIFY(__LINE__)


/** \} */
#endif  /* cool_cool_hpp_included */
