/* Copyright (c) 2003-2005, Sven Suursoho
 * See LICENSE for details */

#ifndef cool_exception_hpp_included
#define cool_exception_hpp_included

/**
 * \defgroup cool_exception Exceptions
 * \ingroup cool
 * \{
 * All library exception class(es) are inherited from base exception class
 * cool::exception which is inherited from std::exception.
 *
 * Header(s):
 *  - \ref exception/exception.hpp
 *  - \ref exception/os_error.hpp
 *
 * Header(s) from submodules:
 *  - \ref net/exception.hpp
 *  - \ref thread/exception.hpp
 * \}
 */

#include <cool/exception/exception.hpp>
#include <cool/exception/os_error.hpp>

#include <cool/net/exception.hpp>
#include <cool/thread/exception.hpp>


#endif  /* cool_exception_hpp_included */
