/* Copyright (c) 2003-2005, Sven Suursoho
 * See LICENSE for details */

#ifndef cool_bits_os_error_hpp_included
#define cool_bits_os_error_hpp_included


#if defined(HAVE_ERRNO_H)
#  include <errno.h>
#endif
#if defined(HAVE_STRING_H)
#  include <string.h>
#endif


namespace cool {
namespace bits {
namespace exception {


typedef int error_type;


inline error_type
last ()
{
  return errno;
}


inline void
last (error_type e)
{
  errno = e;
}


inline const char *
string (error_type e)
{
  return strerror(e);
}


}   // namespace exception
}   // namespace bits
}   // namespace cool


#endif  /* cool_bits_os_error_hpp_included */
