/* Copyright (c) 2003-2005, Sven Suursoho
 * See LICENSE for details */

#ifndef cool_log_stream_writer_hpp_included
#define cool_log_stream_writer_hpp_included

/**
 * \file log_stream_writer.hpp
 * \author Sven Suursoho
 *
 * \brief Class(es): cool::log_stream_writer
 *
 * In module \ref cool_log.
 */

#include <cool/cool.hpp>
#include <cool/log/log.hpp>
#include <cool/log/writer.hpp>
#if defined(ostream_header)
#  include ostream_header
#else
#  include iostream_header
#endif


namespace cool {
/** \addtogroup cool_log */
/** \{ */


/**
 * \brief
 */
template <typename format>
class COOL_API log_stream_writer: public log_writer<format>
{
  public:

      log_stream_writer (STD_ ostream &os): os_(os) { }


  private:

      virtual void log (log::level_type level, const char *msg) {
          os_ << msg << STD_ endl;
      }

      STD_ ostream &os_;
};


/** \} */
}   // namespace cool


#endif  /* cool_log_stream_writer_hpp_included */
