/* Copyright (c) 2003-2005, Sven Suursoho
 * See LICENSE for details */

#ifndef cool_log_timestamp_format_hpp_included
#define cool_log_timestamp_format_hpp_included

/**
 * \file timestamp_format.hpp
 * \author Sven Suursoho
 *
 * \brief Class(es): cool::log_timestamp_format
 *
 * In module \ref cool_log.
 */

#include <cool/cool.hpp>
#if defined(sstream_header)
#  include sstream_header
#else
#  include strstream_header
#endif


namespace cool {
/** \addtogroup cool_log */
/** \{ */


/**
 * \brief
 */
class COOL_API log_timestamp_format
{
  public:

      const char *operator() (const log::event_type &ev) {
          char timestamp[sizeof("YYYY-MM-DD HH:MM:SS ") + 1];
          strftime(timestamp, sizeof(timestamp),
                  "%Y-%m-%d %H:%M:%S ", localtime((time_t *)&ev.time.sec));
          line << timestamp << log::level_string(ev.level)
              << ": " << ev.message;
          return line.str().c_str();
      }


  private:

      STD_ ostringstream line;
};


/** \} */
}   // namespace cool


#endif  /* cool_log_timestamp_format_hpp_included */
