/* Copyright (c) 2003-2005, Sven Suursoho
 * See LICENSE for details */

#ifndef cool_net_bits_client_socket_hpp_included
#define cool_net_bits_client_socket_hpp_included


namespace cool {
namespace bits {
namespace net {


bool connect (socket_base::socket_type s, const socket::address &a);
bool is_connected (socket_base::socket_type s);
int recv (socket_base::socket_type s, char *buf, int len,
        socket_base::io_flags_type f);
int recvfrom (socket_base::socket_type s, socket::address &a,
        char *buf, int len, socket_base::io_flags_type f);
int send (socket_base::socket_type s, char *buf, int len,
        socket_base::io_flags_type f);
int sendto (socket_base::socket_type s, const socket::address &a,
        char *buf, int len, socket_base::io_flags_type f);


inline void
shutdown (socket_base::socket_type s, socket_base::shutmode_type how)
{
  if (::shutdown(s, how) == -1)
      throw_last("shutdown", COOL_LOCUS);
}


}   // namespace net
}   // namespace bits
}   // namespace cool


#endif  /* cool_net_bits_client_socket_hpp_included */
