/* Copyright (c) 2003-2005, Sven Suursoho
 * See LICENSE for details */

#ifndef cool_net_inetstream_hpp_included
#define cool_net_inetstream_hpp_included

/**
 * \file inetstream.hpp
 * \author Sven Suursoho
 *
 * \brief Class(es): cool::inetstream, cool::iinetstream, cool::oinetstream
 *
 * In module \ref cool_netstream.
 */

#include <cool/cool.hpp>
#include <cool/net/inet_socket.hpp>
#include <cool/net/socketstream.hpp>


namespace cool {
/** \addtogroup cool_netstream */
/** \{ */


/** @brief INET socket input stream */
typedef isocketstream<inet> iinetstream;

/** @brief INET socket output stream */
typedef osocketstream<inet> oinetstream;

/** @brief INET socket I/O stream */
typedef socketstream<inet> inetstream;


/** \} */
}   // namespace cool


#endif  /* cool_net_inetstream_hpp_included */
