/* Copyright (c) 2003-2005, Sven Suursoho
 * See LICENSE for details */

#ifndef cool_net_localstream_hpp_included
#define cool_net_localstream_hpp_included

/**
 * \file localstream.hpp
 * \author Sven Suursoho
 *
 * \brief Class(es): cool::localstream, cool::ilocalstream, cool::olocalstream
 *
 * In module \ref cool_netstream.
 */

#include <cool/cool.hpp>
#include <cool/net/local_socket.hpp>
#include <cool/net/socketstream.hpp>


namespace cool {
/** \addtogroup cool_netstream */
/** \{ */


/** @brief INET socket input stream */
typedef isocketstream<local> ilocalstream;

/** @brief INET socket output stream */
typedef osocketstream<local> olocalstream;

/** @brief INET socket I/O stream */
typedef socketstream<local> localstream;


/** \} */
}   // namespace cool


#endif  /* cool_net_localstream_hpp_included */
