/* Copyright (c) 2003-2005, Sven Suursoho
 * See LICENSE for details */

#ifndef cool_thread_exception_hpp_included
#define cool_thread_exception_hpp_included

/**
 * \file thread_exception.hpp
 * \author Sven Suursoho
 *
 * \brief Class(es): cool::lock_error
 *
 * In module \ref cool_thread.
 */

#include <cool/cool.hpp>
#include <cool/exception/exception.hpp>


namespace cool {
/** \addtogroup cool_thread */
/** \{ */


/**
 * \class lock_error
 * \brief Thrown whenever error is detected during thread locking operations.
 */
EXCEPTION_CLASS(lock_error, exception);


/** \} */
}   // namespace cool


#endif  /* cool_thread_exception_hpp_included */
