/* Copyright (c) 2003-2005, Sven Suursoho
 * See LICENSE for details */

#ifndef cool_util_noncopyable_hpp_included
#define cool_util_noncopyable_hpp_included

/**
 * \file noncopyable.hpp
 * \author Sven Suursoho
 *
 * \brief Class(es): cool::noncopyable
 *
 * In module \ref cool_util.
 */

#include <cool/cool.hpp>


namespace cool {
/** \addtogroup cool_util */
/** \{ */


/**
 * \brief Noncopyable class interface.
 *
 * Classes inherited from noncopyable can't be copied.
 */
class COOL_API noncopyable
{
  protected:

      noncopyable () {}
      ~noncopyable () {}


  private:

      noncopyable (const noncopyable &);
      const noncopyable &operator= (const noncopyable &);
};


/** \} */
}   // namespace cool


#endif  /* cool_util_noncopyable_hpp_included */
