dnl Copyright (c) 2005, Sven Suursoho
dnl See LICENSE for details


dnl Check whether namespace std is used
AC_DEFUN([SS_CXX_NAMESPACE_STD],
[
    AC_REQUIRE([SS_CXX_NAMESPACE])
    AC_LANG_SAVE
    AC_LANG(C++)

    AC_CACHE_CHECK([whether namespace std is defined],
        ss_cv_cxx_namespace_std,
        [
            if test "$ss_cv_cxx_namespace" = "yes"; then
                if test -z "$ss_cv_cxx_header_iostream"; then
                    dnl We need iostream_header
                    SS_CXX_HEADER(iostream)
                fi
                AC_TRY_COMPILE(
                    [#include iostream_header],
                    [std::cout << std::endl],
                    [ss_cv_cxx_namespace_std=yes],
                    [ss_cv_cxx_namespace_std=no]
                )
            else
                ss_cv_cxx_namespace_std=no
            fi
        ]
    )
    if test "$ss_cv_cxx_namespace_std" = "yes"; then
        AC_DEFINE(STD_, [std::], [use namespace std])
    else
        AC_DEFINE(STD_, [/**/], [do not use namespace std])
    fi

    AC_LANG_RESTORE
])
