dnl Copyright (c) 2005, Sven Suursoho
dnl See LICENSE for details


dnl Check whether streambuf::showmanyc is const member
AC_DEFUN([SS_CXX_STREAMBUF_SHOWMANYC],
[
    AC_LANG_SAVE
    AC_LANG(C++)

    AC_REQUIRE([SS_CXX_NAMESPACE_STD])

    AC_CACHE_CHECK([whether streambuf::showmanyc() is const member],
        [ss_streambuf_showmanyc_const],
        [
            AC_TRY_COMPILE([#include iostream_header
                class mybuf: public STD_ streambuf {
                  public:
                      virtual int showmanyc() const { return 0; }
                };
                ],
                [mybuf bf; return bf.showmanyc();],
                [ss_streambuf_showmanyc_const=yes],
                [ss_streambuf_showmanyc_const=no]
            )
        ]
    )

    if test $ss_streambuf_showmanyc_const = yes; then
        AC_DEFINE(SS_SHOWMANYC_CONST, const, [const member])
    else
        AC_DEFINE(SS_SHOWMANYC_CONST, /* const */, [non-const member])
    fi

    AC_LANG_RESTORE
])
