dnl Copyright (c) 2005, Sven Suursoho
dnl See LICENSE for details


dnl Check for socklen_t type
AC_DEFUN([SS_SOCKET_SOCKLEN_TYPE],
[
    AC_LANG_SAVE
    AC_LANG(C)

    AC_CHECK_HEADERS([ \
        sys/socket.h \
        sys/types.h \
    ])

    TMP_CFLAGS=${CFLAGS}
    if test $GCC = yes; then
        CFLAGS="-Wall -Werror -pedantic ${CFLAGS}"
    fi

    AC_MSG_CHECKING([socklen_t type])
    AC_CACHE_VAL(
        [ss_cv_type_socklen],
        [
            for ss_cv_type_socklen in socklen_t size_t 'unsigned int' int; do
                AC_TRY_COMPILE([
#ifndef _XOPEN_SOURCE
#  define _XOPEN_SOURCE 500
#endif
#ifndef _XOPEN_SOURCE_EXTENDED
#  define _XOPEN_SOURCE_EXTENDED
#endif
#ifndef _POSIX_C_SOURCE
#  define _POSIX_C_SOURCE 199506L
#endif
#if !defined(_POSIX_VERSION) && defined(__FreeBSD__)
#  define _POSIX_VERSION _POSIX_C_SOURCE
#endif
#ifdef HAVE_SYS_TYPES_H
#  include <sys/types.h>
#endif
#ifdef HAVE_SYS_SOCKET_H
#  include <sys/socket.h>
#endif
                    ],
                    [$ss_cv_type_socklen t; accept(0, 0, &t);],
                    [ac_found=yes; break],
                    [ac_found=not_found]
                )
            done
        ]
    )

    CFLAGS=${TMP_CFLAGS}

    AC_MSG_RESULT([$ss_cv_type_socklen])
    if test $ss_cv_type_socklen != not_found; then
        AC_DEFINE_UNQUOTED(SS_SOCKLEN_T, $ss_cv_type_socklen,
            [socket address length])
    fi

    AC_LANG_RESTORE
])
