dnl Copyright (c) 2005, Sven Suursoho
dnl See LICENSE for details


dnl Check for mutex attribute constants
AC_DEFUN([SS_THREAD_MUTEX_ATTR_VALUE],
[
    AC_LANG_SAVE
    AC_LANG(C)

    AC_REQUIRE([SS_THREADING])

    AC_CACHE_CHECK([mutex attribute values],
        [ss_cv_mutex_attr_value],
        [
            AC_TRY_COMPILE([
#if defined(HAVE_PTHREAD_H)
#  include <pthread.h>
#endif
                ],
                [return PTHREAD_MUTEX_NORMAL;],
                [ss_cv_mutex_attr_value=standard],
                [
                    AC_TRY_COMPILE([
#if defined(HAVE_PTHREAD_H)
#  include <pthread.h>
#endif
                        ],
                        [return PTHREAD_MUTEX_FAST_NP;],
                        [ss_cv_mutex_attr_value=np],
                        [ss_cv_mutex_attr_value=none]
                    )
                ]
            )
        ]
    )

    if test $ss_cv_mutex_attr_value = standard; then
        AC_DEFINE(HAVE_MUTEX_STANDARD, 1, [Posix standard mutexes])
    elif test $ss_cv_mutex_attr_value = np; then
        AC_DEFINE(HAVE_MUTEX_NP, 1, [Nonportable with _NP suffix])
    fi
])
