dnl Copyright (c) 2005, Sven Suursoho
dnl See LICENSE for details


dnl Check for mutex attribute setting function
AC_DEFUN([SS_THREAD_MUTEX_TIMEDLOCK_FUNC],
[
    AC_LANG_SAVE
    AC_LANG(C)

    AC_REQUIRE([SS_THREADING])

    AC_CACHE_CHECK([whether we have pthread_mutex_timedlock],
        [ss_cv_mutex_timedlock_func],
        [
            AC_TRY_COMPILE([
#if defined(HAVE_PTHREAD_H)
#  include <pthread.h>
#endif
                ],
                [pthread_mutex_timedlock(0, 0);],
                [ss_cv_mutex_timedlock_func=yes],
                [ss_cv_mutex_timedlock_func=no]
            )
        ]
    )

    if test $ss_cv_mutex_timedlock_func = yes; then
        AC_DEFINE(HAVE_PTHREAD_MUTEX_TIMEDLOCK, 1,
            [Have pthread_mutex_timedlock])
    fi

    AC_LANG_RESTORE
])
