dnl Copyright (c) 2005, Sven Suursoho
dnl See LICENSE for details


dnl Check for function used to sleep
AC_DEFUN([SS_THREAD_SLEEP_FUNC],
[
    AC_LANG_SAVE
    AC_LANG(C)

    AC_REQUIRE([SS_THREADING])

    dnl Check for time header files
    AC_CHECK_HEADERS([time.h])

    AC_CACHE_CHECK([whether to use pthread_delay_np or nanosleep],
        [ss_cv_sleep_func],
        [
            AC_TRY_COMPILE([
#if defined(HAVE_TIME_H)
#  include <time.h>
#endif
                ],
                [nanosleep(0, 0);],
                [ss_cv_sleep_func=nanosleep],
                [
                    AC_TRY_COMPILE([
#if defined(HAVE_PTHREAD_H)
#  include <pthread.h>
#endif
                        ],
                        [pthread_delay_np(0);],
                        [ss_cv_sleep_func=pthread_delay_np],
                        [ss_cv_sleep_func=none]
                    )
                ]
            )
        ]
    )

    if test $ss_cv_sleep_func = nanosleep; then
        AC_DEFINE(HAVE_NANOSLEEP, 1, [Have nanosleep])
    elif test $ss_cv_sleep_func = pthread_delay_np; then
        AC_DEFINE(HAVE_PTHREAD_DELAY_NP, 1, [Have pthread_delay_np])
    fi

    AC_LANG_RESTORE
])
