dnl Copyright (c) 2005, Sven Suursoho
dnl See LICENSE for details


dnl Check for function yielding CPU slice
AC_DEFUN([SS_THREAD_YIELD_FUNC],
[
    AC_LANG_SAVE
    AC_LANG(C)

    AC_REQUIRE([SS_THREADING])

    dnl Check for time header files
    AC_CHECK_HEADERS([sched.h])

    AC_CACHE_CHECK([whether to use sched_yield or pthread_yield],
        [ss_cv_yield_func],
        [
            AC_TRY_COMPILE([
#if defined(HAVE_SCHED_H)
#  include <sched.h>
#endif
                ],
                [sched_yield();],
                [ss_cv_yield_func=sched_yield],
                [
                    AC_TRY_COMPILE([
#if defined(HAVE_PTHREAD_H)
#  include <pthread.h>
#endif
                        ],
                        [pthread_yield();],
                        [ss_cv_yield_func=pthread_yield],
                        [ss_cv_yield_func=none]
                    )
                ]
            )
        ]
    )

    if test $ss_cv_yield_func != none; then
        AC_DEFINE_UNQUOTED(SS_THREAD_YIELD, $ss_cv_yield_func,
            [Function to yield remaining CPU time slice])
    fi

    AC_LANG_RESTORE
])
