/* Copyright (c) 2003-2005, Sven Suursoho
 * See LICENSE for details */

#include <cool/config/config.hpp>


namespace cool {


template <class container>
basic_config<container>::basic_config (config_parser &parser, STD_ istream &is)
{
  while (parser.next(is)) {
      int k, v;
      const char *key = parser.key(&k);
      const char *value = parser.value(&v);

      char *key_value = (char *)malloc(k + v + 2);
      if (!key_value)
          raise<resource_error>(COOL_LOCUS);

      // copy key (+'\0')
      memcpy(key_value, key, k + 1);

      // copy value (+'\0')
      memcpy(key_value + k + 1, value, v + 1);

      // store in container
      (*this)[key_value] = key_value + k + 1;
  }
}


// instantiate class
template class basic_config<STD_ map<const char *, const char *, cool::less_strcmp> >;


}   // namespace cool
