/* Copyright (c) 2003-2005, Sven Suursoho
 * See LICENSE for details */

#include <cool/log/log.hpp>


namespace cool {


log &
log::write (level_type level, const char *fmt, ...)
{
  va_list va;
  va_start(va, fmt);
  writeva(level, fmt, va);
  va_end(va);
  return *this;
}


#define DEFINE_LOG_METHOD(level) \
    log & \
    log::level (const char *fmt, ...) \
    { \
      va_list va; \
      va_start(va, fmt); \
      writeva(level_##level, fmt, va); \
      va_end(va); \
      return *this; \
    }


DEFINE_LOG_METHOD(emerg)
DEFINE_LOG_METHOD(alert)
DEFINE_LOG_METHOD(crit)
DEFINE_LOG_METHOD(err)
DEFINE_LOG_METHOD(warn)
DEFINE_LOG_METHOD(notice)
DEFINE_LOG_METHOD(info)
DEFINE_LOG_METHOD(debug)


#undef DEFINE_LOG_METHOD


}   // namespace cool
