/* Copyright (c) 2003-2005, Sven Suursoho
 * See LICENSE for details */

#include <cool/net/socket_base.hpp>


namespace cool {


socket_base::family_type socket_base::local =
    socket_base::family_type(AF_UNIX);
socket_base::family_type socket_base::inet =
    socket_base::family_type(AF_INET);

socket_base::style_type socket_base::stream =
    socket_base::style_type(SOCK_STREAM);
socket_base::style_type socket_base::datagram =
    socket_base::style_type(SOCK_DGRAM);
socket_base::style_type socket_base::seqpacket =
    socket_base::style_type(SOCK_SEQPACKET);
socket_base::style_type socket_base::raw =
    socket_base::style_type(SOCK_RAW);
socket_base::style_type socket_base::rdm =
    socket_base::style_type(SOCK_RDM);
  
socket_base::shutmode_type socket_base::r =
    socket_base::shutmode_type(SHUT_RD);
socket_base::shutmode_type socket_base::w =
    socket_base::shutmode_type(SHUT_WR);
socket_base::shutmode_type socket_base::rw =
    socket_base::shutmode_type(SHUT_RDWR);

socket_base::io_flags_type socket_base::oob =
    socket_base::io_flags_type(MSG_OOB);
socket_base::io_flags_type socket_base::peek =
    socket_base::io_flags_type(MSG_PEEK);
socket_base::io_flags_type socket_base::waitall =
    socket_base::io_flags_type(MSG_WAITALL);
socket_base::io_flags_type socket_base::trunc =
    socket_base::io_flags_type(MSG_TRUNC);

socket_base::option_type socket_base::debug =
    socket_base::option_type(SO_DEBUG);
socket_base::option_type socket_base::reuseaddr =
    socket_base::option_type(SO_REUSEADDR);
socket_base::option_type socket_base::keepalive =
    socket_base::option_type(SO_KEEPALIVE);
socket_base::option_type socket_base::dontroute =
    socket_base::option_type(SO_DONTROUTE);
socket_base::option_type socket_base::broadcast =
    socket_base::option_type(SO_BROADCAST);
socket_base::option_type socket_base::linger =
    socket_base::option_type(SO_LINGER);
socket_base::option_type socket_base::oobinline =
    socket_base::option_type(SO_OOBINLINE);
socket_base::option_type socket_base::sndbuf =
    socket_base::option_type(SO_SNDBUF);
socket_base::option_type socket_base::rcvbuf =
    socket_base::option_type(SO_RCVBUF);
socket_base::option_type socket_base::error =
    socket_base::option_type(SO_ERROR);
socket_base::option_type socket_base::sock_style =
    socket_base::option_type(SO_TYPE);

socket_base::level_type socket_base::socket_level =
    socket_base::level_type(SOL_SOCKET);

socket_base::event_type socket_base::no_events =
    socket_base::event_type(0);
socket_base::event_type socket_base::in =
    socket_base::event_type(1);
socket_base::event_type socket_base::out =
    socket_base::event_type(2);
socket_base::event_type socket_base::except =
    socket_base::event_type(4);

socket_base::family_type socket_base::def::family =
    socket_base::inet;
socket_base::style_type socket_base::def::style =
    socket_base::stream;
socket_base::io_flags_type socket_base::def::io_flags =
    socket_base::io_flags_type(0);

int socket_base::somaxconn =
    SOMAXCONN;


}   // namespace cool
