/* Copyright (c) 2003-2005, Sven Suursoho
 * See LICENSE for details */

#include <cool/thread/barrier.hpp>


namespace cool {


bool
barrier::wait ()
{
  mutex::scoped_lock guard(mutex_);
  unsigned int gen = generation_;

  if (--count_ == 0) {
      generation_++;
      count_ = threshold_;
      cond_.notify_all();
      return true;
  }

  while (gen == generation_)
      cond_.wait(guard);
  return false;
}


}   // namespace cool
