/* Copyright (c) 2003-2005, Sven Suursoho
 * See LICENSE for details */

#include <cool/thread/once.hpp>


namespace {

    pthread_key_t key;
    pthread_once_t once = PTHREAD_ONCE_INIT;
    typedef void (*once_callback)();

}


extern "C"
{

  static void
  key_init ()
  {
    pthread_key_create(&key, 0);
  }


  static void
  do_once ()
  {
    once_callback *cb =
        reinterpret_cast<once_callback*>(pthread_getspecific(key));
    (**cb)();
  }

}


namespace cool {

void call_once (void (*func)(), once_flag &flag)
{
  pthread_once(&once, &key_init);
  pthread_setspecific(key, &func);
  pthread_once(&flag, do_once);
}

}   // namespace cool
