/* Copyright (c) 2003-2005, Sven Suursoho
 * See LICENSE for details */

#undef NDEBUG
#include <assert.h>

#if defined(INCLUDE_MODULE)
#  include <cool/thread.hpp>
#else
#  include <cool/thread/barrier.hpp>
#  include <cool/thread/thread_list.hpp>
#endif
#include iostream_header


const int thread_count = 10;
cool::barrier barrier(thread_count);
cool::mutex mutex;

int got[] = { 0, 0 };


void
thread_func (void *)
{
  for (int i = 0;  i < 5;  ++i) {
      bool which = barrier.wait();
      cool::mutex::scoped_lock guard(mutex);
      got[which]++;
  }
}


int
main (int argc, char *argv[])
{
  try {
      cool::thread_list threads;
      for (int i = 0;  i < thread_count;  ++i)
          threads.create(thread_func);
      threads.join_all();

      assert(got[true] == 5);
      assert(got[false] == 45);
  }
  catch (const cool::exception &e) {
      STD_ cout << e << STD_ endl;
      return 1;
  }
  catch (STD_ exception &e) {
      STD_ cout << e.what() << STD_ endl;
      return 1;
  }

  return 0;
}
