/* Copyright (c) 2003-2005, Sven Suursoho
 * See LICENSE for details */

#undef NDEBUG
#include <assert.h>

#if defined(INCLUDE_MODULE)
#  include <cool/net.hpp>
#else
#  include <cool/net/inet_address.hpp>
#endif
#include <cool/exception/exception.hpp>


#include iostream_header


int
main (int argc, char *argv[])
{
  try {
      try {
          cool::inet_address o("non-existing-host");
          assert(!"cool::host_not_found should be thrown!");
      }
      catch (const cool::host_not_found &e) {}

      try {
          cool::inet_address o;
          o.iface("non-existing-iface");
          assert(!"cool::iface_not_found should be thrown!");
      }
      catch (const cool::iface_not_found &e) {}
  
      cool::inet_address a(cool::inet_address::loopback);
      assert(a.ip() == cool::inet_address::loopback);
      assert(strcmp(a.c_str(), "127.0.0.1") == 0);
  
      cool::inet_address b;
      assert(a != b);
      b = "localhost";
      assert(a == b);
      assert(a == b.iface("lo"));
  }
  catch (const cool::exception &e) {
      STD_ cout << e << STD_ endl;
      return 1;
  }
  catch (const STD_ exception &e) {
      STD_ cout << e.what() << STD_ endl;
      return 1;
  }

  return 0;
}
