/* Copyright (c) 2003-2005, Sven Suursoho
 * See LICENSE for details */

#undef NDEBUG
#include <assert.h>

#if defined(INCLUDE_MODULE)
#  include <cool/thread.hpp>
#else
#  include <cool/thread/once.hpp>
#  include <cool/thread/thread_list.hpp>
#endif
#include iostream_header


int once_check_value = 0;
cool::once_flag once_flag = COOL_ONCE_INIT;


void
init_once_check_value ()
{
  once_check_value++;
}


void
thread_func (void *)
{
  cool::call_once(init_once_check_value, once_flag);
}


int
main (int argc, char *argv[])
{
  try {
      const int count = 3;
      cool::thread_list threads;
      for (int i = 0;  i < count;  ++i)
          threads.create(thread_func);
      threads.join_all();
      assert(once_check_value == 1);
  }
  catch (STD_ exception &e) {
      STD_ cout << e.what() << STD_ endl;
      return 1;
  }

  return 0;
}
