/* Copyright (c) 2003-2005, Sven Suursoho
 * See LICENSE for details */

#undef NDEBUG
#include <assert.h>

#if defined(INCLUDE_MODULE)
#  include <cool/exception.hpp>
#else
#  include <cool/exception/os_error.hpp>
#endif
#include iostream_header


int
main (int argc, char *argv[])
{
  try {
      try {
          cool::os_error::last(ENOMEM);
          assert(cool::os_error::last() == ENOMEM);

          cool::os_error e;
          assert(e == ENOMEM);

          raise(cool::os_error("main"), COOL_LOCUS);
          assert(!"Shouldn't reach here!");
      }
      catch (cool::os_error &e) {
          assert(e.locus != 0);
          assert(strcmp(e.what(), "os_error") == 0);
          assert(strcmp(e.func(), "main") == 0);
          assert(e == ENOMEM);
          assert(e.detail() != 0);
          assert(0 == strcmp(e.detail(),
              cool::os_error::string(cool::os_error::last())));
          throw;
      }

      assert(!"Shouldn't reach here");
  }
  catch (STD_ exception &e) {
      assert(strcmp(e.what(), "os_error") == 0);
  }

  return 0;
}
