/* Copyright (c) 2003-2005, Sven Suursoho
 * See LICENSE for details */

#undef NDEBUG
#include <assert.h>
#include <string.h>

#if defined(INCLUDE_MODULE)
#  include <cool/process.hpp>
#else
#  include <cool/process/process.hpp>
#endif
#include iostream_header


int
main (int argc, char *argv[])
{
  try {
      cool::process process;

      cool::process::id_type parent = process.id();
      cool::process::id_type child = process.fork();
      if (child) {
          // in parent
          cool::process::status_type status;
          assert(process.wait_any(&status) == child);
          assert(status == 3);
      }
      else {
          // in child
          assert(process.id() == ::getpid());
          assert(parent == process.parent());
          assert(parent == ::getppid());

          return 3;
      }

      // these paths might not be correct
      assert(process.spawn("/bin/true") == 0);
      assert(process.spawn("/bin/false") > 0);

      process.setenv("X", "1");
      assert(strcmp(process.getenv("X"), "1") == 0);
  }
  catch (STD_ exception &e) {
      STD_ cout << e.what() << STD_ endl;
      return 1;
  }

  return 0;
}
