/* Copyright (c) 2003-2005, Sven Suursoho
 * See LICENSE for details */

#undef NDEBUG
#include <assert.h>

#if defined(INCLUDE_MODULE)
#  include <cool/net.hpp>
#else
#  include <cool/net/socket_pair.hpp>
#  include <cool/net/local_socket.hpp>
#endif
#include iostream_header


int
main (int argc, char *argv[])
{
  char data[] = "hello";
  try {
      // only UNIX sockets are supported
      cool::socket_pair<cool::local> sp(cool::socket::datagram);

      // send data
      assert(sp.first.send(data, sizeof(data) - 1) == sizeof(data) - 1);

      // receive data
      char buf[sizeof(data)];
      int length = sp.second.recv(buf, sizeof(buf));

      // check equality
      assert(length == sizeof(data) - 1);
      assert(strncmp(data, buf, length) == 0);
  }
  catch (STD_ exception &e) {
      STD_ cout << e.what() << STD_ endl;
      return 1;
  }

  return 0;
}
