/* Copyright (c) 2003-2005, Sven Suursoho
 * See LICENSE for details */

#undef NDEBUG
#include <assert.h>

#if defined(INCLUDE_MODULE)
#  include <cool/time.hpp>
#else
#  include <cool/time/time.hpp>
#endif
#include iostream_header


int
main (int argc, char *argv[])
{
  try {
      cool::time t1, t2(3);
      assert(t1 < t2);
      assert(t1.now(3) >= t2);
      t1.now(), t2.now();
      assert(t1 <= t2);
      assert((time_t)cool::time::get() <= ::time(0));

      char buf[26];
      t1.nsec = 0;
      t2 = cool::as<cool::time>(t1.as_iso8601(buf));
      assert(t1 == t2);
  }
  catch (cool::exception &e) {
      STD_ cout << e << STD_ endl;
      return 1;
  }
  catch (STD_ exception &e) {
      STD_ cout << e.what() << STD_ endl;
      return 1;
  }

  return 0;
}
