create schema plproxy;

create function plproxy_call_handler () returns language_handler
    as 'libplproxy'
    language c;

create language plproxy
    handler plproxy_call_handler;


/* new_status:
 *  - online
 *  - offline
 *  - locked
 */
create function plproxy.set_status (new_status text) returns text
    as 'libplproxy', 'set_pool_status'
    language C;


/* Query connection pooler's status. Possible returned values:
 *  - online
 *  - offline
 */
create function plproxy.get_status () returns text
    as 'libplproxy', 'get_pool_status'
    language C;


/* Implemented only if during compilation (#undef NDEBUG)
 *
 * operation:
 *  - on: collect profiler data (default is off)
 *  - off: stop collecting profiler data
 *  - reset: reset profiler data
 *  - get: get profiler data (accumulated since laste 'reset')
 */
create function plproxy.profiler (operation text) returns text
    as 'libplproxy', 'profiler'
    language C;
