-- connect to main database and create test function
set client_min_messages = error;
-- show only unaligned rows
\t \a
\c


-- create partitions
/*
-- p1
create database p1;
update plproxy.db_partition
    set connect_string = 'dbname=p1'
    where partition_name = 'userdb_p1';

-- p2
create database p2;
update plproxy.db_partition
    set connect_string = 'dbname=p2'
    where partition_name = 'userdb_p2';
*/
--


-- create simple tests on both partitions
\c p1
\i assert.sql
\i testfn.types.sql
\i partition.testfn.sql
\i testfn.parameters.sql

/*
\c p2
\i assert.sql
\i testfn.types.sql
\i partition.testfn.sql
\i testfn.parameters.sql
*/


-- run tests again through proxydb
\c
\i testfn.types.sql
\i proxydb.testfn.sql
\i assert.sql
\i testfn.parameters.sql


-- clean up
/*
drop database p1;
drop database p2;
drop function assert (bool);
\i testfn.drop.sql
drop type test_tuple_type cascade;
*/


-- restore previous settings
\t \a
