-- create corresponding proxydb functions


create or replace
function test_bytea (v text, data bytea, retnull boolean)
    returns bytea
    language plproxy
as $$
    cluster userdb;
    /* kommentaar */
    partition by plproxy.get_hash($1);
    -- ka kommentaar
$$;


create or replace
function test_text (v text, retnull boolean)
    returns text
    language plproxy
as $$
    cluster userdb;
    partition by plproxy.get_hash($1);
$$;


create or replace
function test_character_17 (v character(17), retnull boolean)
    returns character(17)
    language plproxy
as $$
    cluster userdb;
    partition by plproxy.get_hash($1);
$$;


create or replace
function test_varchar_15 (v varchar(15), retnull boolean)
    returns varchar(15)
    language plproxy
as $$
    cluster userdb;
    partition by plproxy.get_hash($1);
$$;


create or replace
function test_integer (v integer, retnull boolean)
    returns integer
    language plproxy
as $$
    cluster userdb;
    partition by plproxy.get_hash($1);
$$;


create or replace
function test_bigint (v bigint, retnull boolean)
    returns bigint
    language plproxy
as $$
    cluster userdb;
    partition by plproxy.get_hash($1);
$$;


create or replace
function test_decimal (v decimal(10,2), retnull boolean)
    returns decimal(10,2)
    language plproxy
as $$
    cluster userdb;
    partition by plproxy.get_hash($1);
$$;


create or replace
function test_real (v real, retnull boolean)
    returns real
    language plproxy
as $$
    cluster userdb;
    partition by plproxy.get_hash($1);
$$;


create or replace
function test_double (v double precision, retnull boolean)
    returns double precision
    language plproxy
as $$
    cluster userdb;
    partition by plproxy.get_hash($1);
$$;


create or replace
function get_hash (cluster_name text, v test_tuple_type)
    returns ret_get_hash
    language plpgsql
as $$
declare
    retval ret_get_hash%ROWTYPE;
begin
    select into retval * from plproxy.get_hash(cluster_name, v.ftext);
    return retval;
end;
$$;


create or replace
function test_tuple (v test_tuple_type, retnull boolean)
    returns test_tuple_type
    language plproxy
as $$
    cluster userdb;
    partition by get_hash($1);
$$;


create or replace
function get_hash (cluster_name text, v boolean)
    returns ret_get_hash
    language plpgsql
as $$
declare
    hash_text text := null;
    retval ret_get_hash%ROWTYPE;
begin
    if v then
        hash_text = 't';
    elsif not v then
        hash_text = 'f';
    end if;
    select into retval * from plproxy.get_hash(cluster_name, hash_text);
    return retval;
end;
$$;


create or replace
function test_boolean (v boolean, retnull boolean)
    returns boolean
    language plproxy
as $$
    cluster userdb;
    partition by get_hash($1);
$$;


create or replace
function test_timestamp (v timestamp, retnull boolean)
    returns timestamp
    language plproxy
as $$
    cluster userdb;
    partition by plproxy.get_hash($1);
$$;


create or replace
function test_setof_integer (num_of_items integer, value integer)
    returns setof integer
    language plproxy
as $$
    cluster userdb;
    partition by plproxy.get_hash($2);
$$;


create or replace
function test_setof_tuple (num_of_items integer, value test_tuple_type)
    returns setof test_tuple_type
    language plproxy
as $$
    cluster userdb;
    partition by get_hash($2);
$$;


create or replace
function test_setof_row (num_of_items integer)
    returns setof pg_cast
    language plproxy
as $$
    cluster userdb;
    partition by plproxy.get_hash($1);
$$;
