-- run assertion checks


-- bytea
select assert(test_bytea = '')
    from test_bytea('hashbythis', '', false);

select assert(test_bytea = '\001\002\003')
    from test_bytea('hashbythis', '\001\002\003', false);

select assert(test_bytea is null)
    from test_bytea('hashbythis', '\001\002\003', true);


-- text
select assert(test_text = '')
    from test_text('', false);

select assert(test_text = 'test_text')
    from test_text('test_text', false);

select assert(test_text is null)
    from test_text('test_text', true);


-- character(17)
select assert(test_character_17 = '')
    from test_character_17('', false);

select assert(test_character_17 = 'test_character_17')
    from test_character_17('test_character_17', false);

select assert(test_character_17 is null)
    from test_character_17('test_character_17', true);


-- varchar(17)
select assert(test_varchar_15 = '')
    from test_varchar_15('', false);

select assert(test_varchar_15 = 'test_varchar_15')
    from test_varchar_15('test_varchar_15', false);

select assert(test_varchar_15 is null)
    from test_varchar_15('test_varchar_15', true);


-- integer
select assert(test_integer = 0)
    from test_integer(0, false);

select assert(test_integer = 1)
    from test_integer(1, false);

select assert(test_integer is null)
    from test_integer(1, true);


-- bigint
select assert(test_bigint = 0)
    from test_bigint(0, false);

select assert(test_bigint = 1)
    from test_bigint(1, false);

select assert(test_bigint is null)
    from test_bigint(1, true);


-- decimal(10,2)
select assert(test_decimal = 0.0)
    from test_decimal(0.0, false);

select assert(test_decimal = 1.1)
    from test_decimal(1.1, false);

select assert(test_decimal is null)
    from test_decimal(1.1, true);


-- real
select assert(test_real > (0.0 - 0.01) and test_real < (0.0 + 0.01))
    from test_real(0.0, false);

select assert(test_real > (1.1 - 0.01) and test_real < (1.1 + 0.01))
    from test_real(1.1, false);

select assert(test_real is null)
    from test_real(1.1, true);


-- double precision
select assert(test_double = 0.0)
    from test_double(0.0, false);

select assert(test_double = 1.2)
    from test_double(1.2, false);

select assert(test_double is null)
    from test_double(1.2, true);


-- test_tuple_type
select assert(
        t.ftext = 'text'
        and t.fcharacter8 = 'charact8'
        and t.fvarchar8 = 'varchar8'
        and t.fsmallint = 1
        and t.finteger = 2
        and t.fbigint = 3
        and t.fdecimal = 4.5
        and (t.freal > (6.7 - 0.01) and t.freal < (6.7 + 0.01))
        and t.fdouble = 8.9
    )
    from test_tuple('(text,charact8,varchar8,1,2,3,4.5,6.7,8.9)', false) t;

select assert(t is null or
        (/* XXX: which is correct whole var is null or each field? */
            t.ftext is null
            and t.fcharacter8 is null
            and t.fvarchar8 is null
            and t.fsmallint is null
            and t.finteger is null
            and t.fbigint is null
            and t.fdecimal is null
            and t.freal is null
            and t.fdouble is null
        )
    )
    from test_tuple('(text,charact8,varchar8,1,2,3,4.5,6.7,8.9)', true) t;


-- boolean
select assert(test_boolean = 't')
    from test_boolean(true, false);

select assert(test_boolean = 'f')
    from test_boolean(false, false);

select assert(test_boolean is null)
    from test_boolean(true, true);


-- timestamp
select assert(test_timestamp = '2005-01-03 09:00:00.0')
    from test_timestamp('2005-01-03 09:00:00.0', false);

select assert(test_timestamp is null)
    from test_timestamp('2005-01-03 09:00:00.0', true);


-- setof integer
select assert(count(*) = 2 and test_setof_integer = 1)
    from test_setof_integer(2, 1)
    group by test_setof_integer;


-- setof test_tuple_type
select assert(count(*) = 2 and
        (
            t.ftext = 'text'
            and t.fcharacter8 = 'charact8'
            and t.fvarchar8 = 'varchar8'
            and t.fsmallint = 1
            and t.finteger = 2
            and t.fbigint = 3
            and t.fdecimal = 4.5
            and (t.freal > (6.7 - 0.01) and t.freal < (6.7 + 0.01))
            and t.fdouble = 8.9
        )
    )
    from test_setof_tuple(2, '(text,charact8,varchar8,1,2,3,4.5,6.7,8.9)') t
    group by t.ftext, t.fcharacter8, t.fvarchar8, t.fsmallint, t.finteger,
        t.fbigint, t.fdecimal, t.freal, t.fdouble;


-- setof row (system table pg_cast, should exist on every PG system)
select assert(count(*) = 2)
    from test_setof_row(2) c
    group by c.castcontext;
