#include <pgclient/error.hpp>
#include <pgclient/connection.hpp>
#include <ctype.h>


namespace pgclient
{


error::error (connection &c)
{
  if (c.connection_)
      what(PQerrorMessage(c.connection_), true);
  else
      what("no low-level PG connection");
}


void
error::what (const char *msg, bool strip_newline)
{
  size_t len = snprintf(message_, sizeof(message_), "%s", msg);
  // TODO check snprintf overflow

  if (strip_newline) {
      while (len > 0 && isspace(message_[len - 1]))
          len--;
      message_[len] = '\0';
  }
}


}   // namespace pgclient
