#include <pool/error.hpp>
#include <pool/config.hpp>
#include <pool/logger.hpp>
#include <pool/signal.hpp>


namespace pgcpool
{


void
exception::global_handler () throw()
{
  try {
      throw;
  }

  catch (const exception &e) {
      std::ostringstream ss;
      ss << e.what();
      if (e.locus)
          ss << " (" << e.locus << ')';
      if (e.info)
          ss << ": " << e.info;
      fatal() << ss.str();
  }

  catch (const cool::os_error &e) {
      fatal() << e;
  }

  catch (const cool::exception &e) {
      fatal() << e;
  }

  catch (const std::exception &e) {
      fatal() << e.what();
  }

  catch (...) {
      fatal() << "unknown exception";
  }

  // initiate shutdown 
  abort();
  signal_handler::shutdown = true;
}


}   // namespace pgcpool
