#ifndef pool_signal_hpp_included
#define pool_signal_hpp_included


/**
 * \file pool/signal.hpp
 * \brief Signal handling stuff
 */


#include <pool/pgcpoold.hpp>
#include <cool/signal/signal.hpp>


namespace pgcpool
{


/** \brief Signal handler structure */
struct signal_handler: public cool::signal::handler
{
  /** \brief Register itself as handler for signal \a s */
  signal_handler (cool::signal::signal_type s): cool::signal::handler(s) {}

  /** \brief Asynchronous callback whenever signal \a s arrives */
  void operator() (cool::signal::signal_type s) {
      switch (s) {
          case cool::signal::term:
          case cool::signal::quit:
          case cool::signal::intr:
              shutdown = true;
              break;

          default:
              break;
      }
  }

  /** \brief Set to true if SIG{TERM|INT|QUIT} is arrived */
  static volatile bool shutdown;
};


}  // namespace pgcpool


#endif  // pool_signal_hpp_included
