#!/bin/bash
#
# Contains killing, dropping and removing. Don't run blindly!
#

# set pgcpoold binary location here, if not in path

if [ ! -x "`which pgcpoold`" ]; then
	echo "pgcpoold binary not in path!"
	exit 1
fi

pkill pgcpoold
sleep 1
rm -f pgcpoold.log

dropdb proxydb
dropdb p1
dropdb p2

set -e
createdb proxydb
createdb p1
createdb p2

# create language and config schema
psql --set ON_ERROR_STOP=1 -f ../../plproxy/db/lang.sql proxydb
psql --set ON_ERROR_STOP=1 -f ../structure/plproxy_schema.sql proxydb

# configure the proxy
psql --set ON_ERROR_STOP=1 -f example1_initcluster.sql proxydb

pgcpoold dbname=proxydb
sleep 1

# create the "application"
psql --set ON_ERROR_STOP=1 -f example1_part.sql  p1
psql --set ON_ERROR_STOP=1 -f example1_part.sql  p2
psql --set ON_ERROR_STOP=1 -f example1_proxy.sql proxydb

# show distribution
psql -f distrib.sql proxydb

# query some accounts
psql -c "select get_account('user0000')" proxydb
psql -c "select get_account('user1000')" proxydb
