-- This is will be installed into each of the partition databases.

BEGIN;

set search_path=public;
set client_min_messages=warning;

create table accounts (
username text primary key,
balance  numeric(7,2)
);

create type ret_get_account AS (
username        text,
balance         numeric(7,2),
partition       text
);

create or replace function get_account(
    i_username text)
returns ret_get_account as 
$$
    select username, balance, current_database()::text from accounts where username = $1;
$$ language sql;

-- update account balance, create new account if nonexistent
-- returns new balance
create or replace function update_account(
        i_username text,
        i_change numeric
        ) returns numeric as $$
declare
    l_balance numeric;
begin
    select balance into l_balance from accounts where username=i_username for update;

    if not found then
        insert into accounts (username, balance) values (i_username, i_change);
    elseif i_change != 0 then
        update accounts set balance = balance + i_change where username=i_username;
    end if;

    return coalesce(l_balance,0) + i_change;
end;
$$ language plpgsql;

END;
