-- This is the will be installed in proxy database, most of the functions 
-- here are in the pl/proxy language.

BEGIN;
set search_path=public;

create type ret_get_account AS (
username        text,
balance         numeric(7,2),
partition       text
);

-- create the proxy function, use the default supplied hash function
create or replace function update_account(text,numeric) returns numeric as $$
cluster mycluster;
partition by plproxy.get_hash($1);
$$ language plproxy;

-- create the proxy function, use the default supplied hash function
create or replace function get_account(text) returns ret_get_account as $$
cluster mycluster;
partition by plproxy.get_hash($1);
$$ language plproxy;

-- generate the accounts
\! echo Generating accounts ...
select update_account('user' || ltrim(to_char(generate_series,'0999')), 0.0) from generate_series(0, 1000)
\g /dev/null
END;
