#!bin/bash
#
# Contains killing, dropping and removing. Don't run blindly!
#

pkill pgcpoold
sleep 1

dropdb p3
dropdb p4

set -e

createdb p3
createdb p4

# configure the proxy
psql --set ON_ERROR_STOP=1 -f example2_split.sql proxydb

# clone the partition databases, do the copies in the same order as split
# eg. p000 was split to p000 and p002, p001 was split to p001 and p003
pg_dump p1 | psql p3  >/dev/null 2>&1
pg_dump p2 | psql p4  >/dev/null 2>&1

# (re)start pgcpoold to refresh the configuration
pgcpoold dbname=proxydb
sleep 1

# check out new distribution
psql proxydb -f distrib.sql

# remove unneeded data from partitions
for i in `seq 0 3`
do
	psql -c "delete from accounts where mod((hashtext(username) & 255) - $i, 4) != 0" p$((i + 1))
done

# distribution should be unchanged
psql proxydb -f distrib.sql

