CREATE OR REPLACE FUNCTION plproxy.alter_partition(
    i_partition_name text ,
    i_connect_string text ,
    i_partition_descr text )
RETURNS text AS $$
-- USED BY: admin to chnage partition connect string or description
-- RETURNS: 200 Ok
-- EXAMPLE: select * from plproxy.alter_partition('userdb_p1', 'dbname=userdb_p1', null);  
DECLARE
    r_partition record;
BEGIN	
    -- get partition record
    r_partition = plproxy.fetch_partition_by_name(i_partition_name);  

    if i_partition_descr is NOT null then
        r_partition.partition_descr = i_partition_descr;
    end if;

    if i_connect_string is NOT null then
        r_partition.connect_string  = i_connect_string;
    end if;

    update plproxy.db_partition set
        partition_descr = r_partition.partition_descr ,
        connect_string  = r_partition.connect_string  
    where id_partition = r_partition.id_partition;
    
    return '200 Ok';
END;
$$ LANGUAGE 'plpgsql' VOLATILE SECURITY DEFINER;
