DROP FUNCTION plproxy.alter_proxy(
    i_proxy_name text ,    
    i_name text ,
    i_value text );

CREATE OR REPLACE FUNCTION plproxy.alter_proxy(
    i_proxy_name text ,
    i_name text ,
    i_value text )
RETURNS text AS $$
-- USED BY: admin to chnage proxy connect string or description
-- RETURNS: 200 Ok
-- EXAMPLE: select * from plproxy.alter_proxy('proxydb_p1', 'dbname=proxydb_p1', null);  
DECLARE
    r_proxy record;
BEGIN	
    -- get proxy record
    r_proxy = plproxy.fetch_proxy_by_name(i_proxy_name);  

    update plproxy.db_proxy_config
       set value = i_value
     where key_proxy = r_proxy.id_proxy
       and name = i_name;
    
    if NOT found then 
        insert into plproxy.db_proxy_config (key_proxy, name, value) values (r_proxy.id_proxy, i_name, i_value);
    end if;
    
    return '200 Ok';
END;
$$ LANGUAGE 'plpgsql' VOLATILE SECURITY DEFINER;
