CREATE OR REPLACE FUNCTION plproxy.fetch_cluster_by_name(i_lookup_key text) RETURNS plproxy.db_cluster AS $$
-- find cluster record by name or raises exception if not found
-- select * from plproxy.get_clsuter_by_name('contactdb');  
DECLARE
    r_result record;
BEGIN
    select * from plproxy.db_cluster where cluster_name = lower(i_lookup_key) into r_result;
    if not found then
        raise exception '400 Cluster with given name="%" NOT found', i_lookup_key;
    end if;
    return r_result;
END;
$$ LANGUAGE 'plpgsql' VOLATILE SECURITY DEFINER;
