CREATE OR REPLACE FUNCTION plproxy.fetch_cluster_conf_by_name(
        i_conf_name text, 
        i_conf_map text) 
        RETURNS plproxy.db_cluster_conf AS $$
-- find cluster configuration record by coniguration name and map
-- used by other functions to vaqlidate input paramteres and 
-- get the configuration record
-- select * from plproxy.get_cluster_conf_by_name('eventdb_V1','-');  
DECLARE
    r_result record;
BEGIN
    select * from plproxy.db_cluster_conf 
    where conf_name = lower(i_conf_name) 
    and conf_map = lower(i_conf_map)
    into r_result;
    if not found then 
        raise exception '400 Configuration with given name="%" and map = "%" NOT found', 
            i_conf_name, i_conf_map;
    end if;
    return r_result;
END;
$$ LANGUAGE 'plpgsql' VOLATILE SECURITY DEFINER;

