CREATE OR REPLACE FUNCTION plproxy.fetch_free_partition_name(
  i_cluster_name text ) 
RETURNS text AS $$
-- find first free partition name for given cluster
-- select * from plproxy.get_free_partition_name('eventdb');  
select min(part_name) from (
    select $1 || '_p' || lpad(generate_series::text, 3, '0') as part_name 
    from generate_series(0, (
        select coalesce(count(1),0)
	from plproxy.db_partition 
        where key_cluster = (
	    select id_cluster from plproxy.db_cluster where cluster_name = lower($1))
    )) 
) names 
where part_name not in (select partition_name from plproxy.db_partition);
$$ LANGUAGE 'sql' VOLATILE SECURITY DEFINER;
