CREATE OR REPLACE FUNCTION plproxy.fetch_partition_by_name(i_partition_name text) RETURNS plproxy.db_partition AS $$
-- find partition record by partition name 
-- select * from plproxy.get_partition('eventdb_p1');  
DECLARE
    r_result record;
BEGIN
    select * from plproxy.db_partition where partition_name = lower(i_partition_name) into r_result;
    if not found then 
        raise exception '400 Partition with given name="%" NOT found', i_partition_name;
    end if;
    return r_result;
END;
$$ LANGUAGE 'plpgsql' VOLATILE SECURITY DEFINER;
