CREATE OR REPLACE FUNCTION plproxy.fetch_proxy_by_name(i_lookup_key text) RETURNS plproxy.db_proxy AS $$
-- find proxy record by name
-- select * from plproxy.get_proxy('central_p1');  
DECLARE
    r_result record;
BEGIN
    select * from plproxy.db_proxy where proxy_name = lower(i_lookup_key) into r_result;
    if not found then
        raise exception '400 Proxy with given name="%" NOT found', i_lookup_key;
    end if;
    return r_result;
END;
$$ LANGUAGE 'plpgsql' VOLATILE SECURITY DEFINER;
