drop type plproxy.ret_get_hash cascade;

create type plproxy.ret_get_hash as (
    conf_map text ,
    hash_nr int2 );

CREATE OR REPLACE FUNCTION plproxy.get_hash(
    i_cluster_name text ,
    i_key_user text )
RETURNS plproxy.ret_get_hash AS $$
-- USED BY: Language to calulate hash values passed to pool
-- calculates map and hash number form username
-- EXAMPLE: select * from plproxy.get_hash('userdb','askoja');
DECLARE
    retval plproxy.ret_get_hash%ROWTYPE;
BEGIN	
    retval.conf_map = '-';
    retval.hash_nr = hashtext(i_key_user) & 255;
    return retval;
END;
$$ LANGUAGE 'plpgsql' VOLATILE SECURITY DEFINER;
