DROP TYPE plproxy.ret_get_proxy_config CASCADE;

CREATE TYPE plproxy.ret_get_proxy_config AS (
  name text ,  
  value text
);

CREATE OR REPLACE FUNCTION plproxy.get_proxy_config(
    i_proxy_name text)
RETURNS SETOF plproxy.ret_get_proxy_config AS $$
-- used by:: pgcpoold to initialize 
--   needed when pool is started or when configuration is changed or reloaded
-- br:: configuration for one proxy is returned
-- returns:: set of records
--   name text
--   value text
-- example::
--   select * from plproxy.get_proxy_config('central');  
    select name, value
    from plproxy.db_proxy prox 
        inner join plproxy.db_proxy_config conf on prox.id_proxy = conf.key_proxy
    where prox.proxy_name = $1;
$$ LANGUAGE 'sql' VOLATILE SECURITY DEFINER;


