CREATE OR REPLACE FUNCTION plproxy.set_active_conf(
    i_cluster_name text, 
    i_conf_name text) 
    RETURNS text AS $$
-- used by:: configuration change script to update active configuration
--    it is called once in each proxy database when configuration is changed
--    or when configuraton must be restored then once more
-- br:: if cluster has no record in active configuration table then create ir
-- returns:: 200 Ok -- when successful
-- example::
--   select * from plproxy.set_activa_conf('userdb', 'userdb_v2');  
BEGIN	
    update plproxy.db_conf 
    set conf_name = lower(i_conf_name) , start_time = now()
    where cluster_name = lower(i_cluster_name);
    if not found then
        insert into plproxy.db_conf ( cluster_name , conf_name , start_time )
        values ( lower(i_cluster_name) , lower(i_conf_name) , now() );
    end if;
    return '200 Ok';
END;
$$ LANGUAGE 'plpgsql' VOLATILE SECURITY DEFINER;
