CREATE OR REPLACE FUNCTION plproxy.set_pool_status(
    i_cluster_name text ,
    i_status text )
    RETURNS text AS $$
-- used by:: configuration change scipt to sends status change command to pool
-- br:: possible status changes
--    OFFLINE to ONLINE - when proxy has been manually put offline
--    ONLINE to LOCKED - when proxy is locked for configuration change
--    LOCKED to ONLINE - when configuration change is finished
--    LOCKED to OFFLINE - when major fuckup hits during configuration change
--    ONLINE to OFFLINE - when proxy must be taken offilen for whatever reasons
--    ONLINE to RELOAD - when configuration has changed but timing is not critical
-- br:: when status is changed from LOCKED to ONLINE then proxy must check
--   if configuration has been changed and if so then reload and recalculate 
-- br:: RELOAD can be used compatible changes are done to the configuration
--   for example partiton is added for which data will arrive in the future
--   or added partition will read data from old partiton over remote procedure call
--   after configuration is reloaded status goes back to ONLINE
--   hash numbers
-- returns:: pool status text
-- example::
--   select * from plproxy.set_pool_status('userdb','LOCKED');  
DECLARE
    v_result text;
BEGIN	
    
    -- TODO -- call aprpriate pool function 
    -- v_result = pool.lock_cluster(i_cluster_name);

    return i_status;
END;
$$ LANGUAGE 'plpgsql' VOLATILE SECURITY DEFINER;
