DROP TYPE plproxy.ret_view_conf_partitions CASCADE;

CREATE TYPE plproxy.ret_view_conf_partitions AS (
  partition_name text,
  hash_count bigint,
  connect_string text);

CREATE OR REPLACE FUNCTION plproxy.view_conf_partitions(text) 
RETURNS SETOF plproxy.ret_view_conf_partitions AS $$
-- good for validating that conf is correct
-- select * from plproxy.get_conf_partitions('eventdb_v1');
select p.partition_name, 
 (select count(1) from plproxy.db_conf_partition 
  where key_partition = p.id_partition 
  and key_cluster_conf = (
    select id_cluster_conf from plproxy.db_cluster_conf where conf_name = LOWER($1))
 ) as hash_count,
 connect_string
from plproxy.db_partition p 
where key_cluster = (
    select key_cluster from plproxy.db_cluster_conf where conf_name = LOWER($1));
$$
  LANGUAGE 'sql' VOLATILE SECURITY DEFINER;
