-- Create ContactDB cluster with 16 partitions
select * from plproxy.create_cluster('userdb','Customer database',3);
-- Marc created version as active
select * from plproxy.set_active_conf('userdb','userdb_V1');
-- Create proxy definition 
select * from plproxy.create_proxy('user_proxy','Proxy for testing combined user db',ARRAY['userdb'],1,100);  
-- Set proxy connect string
select * from plproxy.change_proxy('user_proxy', 'dbname=proxydb host=cph_db1 user=proxy_admin', null); 
-- Set partiton connect strings
select * from plproxy.change_partition('userdb_p000', 'dbname=balancedb_test host=192.168.125.155 user=proxy password=bar00l', 'bal+ui+so');  
select * from plproxy.change_partition('userdb_p001', 'dbname=balancedb_test host=192.168.125.157 user=proxy password=bar00l', 'bal+ui+so');  
select * from plproxy.change_partition('userdb_p002', 'dbname=balancedb_test host=192.168.125.158 user=proxy password=bar00l', 'bal+ui+so');  
-- Review connect strings
select * from plproxy.get_proxy_connections('user_proxy');
-- Review cluster maps
select * from plproxy.get_cluster_maps('userdb');
-- Review hash - partition - dbnumber mapping
select hash_nr, partition_name, connect_string
    from plproxy.get_cluster_maps('userdb') 
    inner join plproxy.db_partition on id_partition = key_partition;;
select hash_nr, hash_nr & 3 as dbnr, partition_name, connect_string
    from plproxy.get_cluster_maps('userdb') 
    inner join db_partition on id_partition = key_partition;;
