-- Create ContactDB cluster with 16 partitions
select * from plproxy.create_cluster('contactdb','Central buddylist',16);
-- Marc created version as active
select * from plproxy.set_active_conf('contactdb','contactdb_V1');
-- Create proxy definition 
select * from plproxy.create_proxy('dbpooler2','ContactDB and EventDB pooler',ARRAY['contactdb'],1,400);  
-- Set proxy connect string
select * from plproxy.change_proxy('dbpooler2', 'dbname=contactdb host=dbpooler2 user=admin', null); 
-- Set partiton connect strings
select * from plproxy.change_partition('contactdb_p000', 'dbname=contactdb_p000 host=192.168.114.163 user=remote_contact', 'user_contact_p000');  
select * from plproxy.change_partition('contactdb_p001', 'dbname=contactdb_p001 host=192.168.114.180 user=remote_contact', 'user_contact_p001');  
select * from plproxy.change_partition('contactdb_p002', 'dbname=contactdb_p002 host=192.168.114.180 user=remote_contact', 'user_contact_p002');  
select * from plproxy.change_partition('contactdb_p003', 'dbname=contactdb_p003 host=192.168.114.182 user=remote_contact', 'user_contact_p003');  
select * from plproxy.change_partition('contactdb_p004', 'dbname=contactdb_p004 host=192.168.114.163 user=remote_contact', 'user_contact_p004');  
select * from plproxy.change_partition('contactdb_p005', 'dbname=contactdb_p005 host=192.168.114.180 user=remote_contact', 'user_contact_p005');  
select * from plproxy.change_partition('contactdb_p006', 'dbname=contactdb host=192.168.114.164 user=remote_contact', 'user_contact_p006');  
select * from plproxy.change_partition('contactdb_p007', 'dbname=contactdb host=192.168.114.164 user=remote_contact', 'user_contact_p007');  
select * from plproxy.change_partition('contactdb_p008', 'dbname=contactdb_p008 host=192.168.114.182 user=remote_contact', 'user_contact_p008');  
select * from plproxy.change_partition('contactdb_p009', 'dbname=contactdb_p009 host=192.168.114.181 user=remote_contact', 'user_contact_p009');  
select * from plproxy.change_partition('contactdb_p010', 'dbname=contactdb host=192.168.114.159 user=remote_contact', 'user_contact_p010');  
select * from plproxy.change_partition('contactdb_p011', 'dbname=contactdb_p011 host=192.168.114.181 user=remote_contact', 'user_contact_p011');  
select * from plproxy.change_partition('contactdb_p012', 'dbname=contactdb host=192.168.114.167 user=remote_contact', 'user_contact_p012');  
select * from plproxy.change_partition('contactdb_p013', 'dbname=contactdb_p013 host=192.168.114.182 user=remote_contact', 'user_contact_p013');  
select * from plproxy.change_partition('contactdb_p014', 'dbname=contactdb_p014 host=192.168.114.181 user=remote_contact', 'user_contact_p014');  
select * from plproxy.change_partition('contactdb_p015', 'dbname=contactdb host=192.168.114.165 user=remote_contact', 'user_contact_p015');  
-- Review connect strings
select * from plproxy.get_proxy_connections('dbpooler2');
-- Review cluster maps
select * from plproxy.get_cluster_maps('contactdb');
-- Review hash - partition - dbnumber mapping
 select hash_nr, hash_nr & 15 as partnr, partition_name, connect_string
    from plproxy.get_cluster_maps('contactdb') 
    inner join plproxy.db_partition on id_partition = key_partition;;

select * from plproxy.create_cluster('eventdb','Event database',8);
select * from plproxy.set_active_conf('eventdb','eventdb_V1');
-- eventdb 
select * from plproxy.change_partition('eventdb_p000', 'dbname=eventdb host=192.168.114.170 user=remote_event', 'event_p000');  
select * from plproxy.change_partition('eventdb_p001', 'dbname=eventdb host=192.168.114.170 user=remote_event', 'event_p001');  
select * from plproxy.change_partition('eventdb_p002', 'dbname=eventdb host=192.168.114.170 user=remote_event', 'event_p002');  
select * from plproxy.change_partition('eventdb_p003', 'dbname=eventdb host=192.168.114.170 user=remote_event', 'event_p003');  
select * from plproxy.change_partition('eventdb_p004', 'dbname=eventdb host=192.168.114.171 user=remote_event', 'event_p004');  
select * from plproxy.change_partition('eventdb_p005', 'dbname=eventdb host=192.168.114.171 user=remote_event', 'event_p005');  
select * from plproxy.change_partition('eventdb_p006', 'dbname=eventdb host=192.168.114.171 user=remote_event', 'event_p006');  
select * from plproxy.change_partition('eventdb_p007', 'dbname=eventdb host=192.168.114.171 user=remote_event', 'event_p007');  


