-- Define cluster
select * from plproxy.create_cluster('eventdb','Event database',1);
select * from plproxy.create_cluster('voicemaildb','Voicemails',1);
select * from plproxy.set_active_conf('eventdb','eventdb_V1');
select * from plproxy.set_active_conf('voicemaildb','voicemaildb_V1');
select * from plproxy.change_partition('eventdb_p000', 'dbname=eventdb_dev', 'events');  
select * from plproxy.change_partition('voicemaildb_p000', 'dbname=voicemaildb_dev','voicemails');  
-- Create proxy definition 
select * from plproxy.create_proxy('dev3','ContactDB and EventDB pooler',ARRAY['eventdb','voicemaildb'],1,3);  
-- Set proxy connect string
select * from plproxy.change_proxy('dev3', 'host=192.168.6.6', null); 
-- Review connect strings
select * from plproxy.get_proxy_connections('dev3');
-- validate 
select hash_nr, hash_nr & 1 as partnr, partition_name, connect_string
    from plproxy.get_cluster_maps('eventdb') 
    inner join plproxy.db_partition on id_partition = key_partition;;

/*
-- test setup
select * from plproxy.change_partition('eventdb_p000', 'dbname=eventdb host=192.168.114.170 user=event_proxy', 'event_p000');  
select * from plproxy.change_partition('eventdb_p001', 'dbname=eventdb host=192.168.114.170 user=event_proxy', 'event_p001');  
select * from plproxy.change_partition('voicemaildb_p000', 'dbname=eventdb host=192.168.114.170 user=event_proxy', 'voice_p000');  
select * from plproxy.change_partition('voicemaildb_p001', 'dbname=eventdb host=192.168.114.170 user=event_proxy', 'voice_p001');  
*/