-- Create ContactDB cluster with 16 partitions
select * from plproxy.create_cluster('skypeoutdb','Skypeout call server',2);
select * from plproxy.create_cluster('balancedb','Customer database',1);
-- Marc created version as active
select * from plproxy.set_active_conf('skypeoutdb','skypeoutdb_V1');
select * from plproxy.set_active_conf('balancedb','balancedb_V1');
-- Create proxy definition 
select * from plproxy.create_proxy('skypeout_proxy','Proxy for testing skypeout',ARRAY['skypeoutdb','balancedb'],1,100);  
-- Set proxy connect string
select * from plproxy.change_proxy('skypeout_proxy', 'dbname=proxydb host=cph_db1 user=proxy_admin', null); 
-- Set partiton connect strings
select * from plproxy.change_partition('skypeoutdb_p000', 'dbname=accountdb_test host=192.168.125.155 user=proxy password=bar00l', 'cdr only');  
select * from plproxy.change_partition('skypeoutdb_p001', 'dbname=accountdb_test host=192.168.125.157 user=proxy password=bar00l', 'cdr only');  
select * from plproxy.change_partition('balancedb_p000', 'dbname=balancedb_test host=192.168.125.158 user=proxy password=bar00l', 'nalance and userinfo');  
-- Review connect strings
select * from plproxy.get_proxy_connections('skypeout_proxy');
-- Review cluster maps
select * from plproxy.get_cluster_maps('skypeoutdb');
select * from plproxy.get_cluster_maps('balancedb');
-- Review hash - partition - dbnumber mapping
 select hash_nr, hash_nr & 15 as partnr, hash_nr & 3 as dbnr, partition_name, connect_string
    from plproxy.get_cluster_maps('skypeoutdb') 
    inner join plproxy.db_partition on id_partition = key_partition;;
select hash_nr, hash_nr & 15 as partnr, hash_nr & 3 as dbnr, partition_name, connect_string
    from plproxy.get_cluster_maps('balancedb') 
    inner join db_partition on id_partition = key_partition;;
